
#property copyright " 2009, BJF Trading group inc."
#property link      "www.iticsoftware.com"

#define major   1
#define minor   0


extern string _tmp0_ = " --- MM section ---";
extern double Lots = 1.0;
extern bool DynamicLot = false;
extern double LotBalancePcnt = 10;


extern string _tmp1_ = " --- Trade section ---";
extern bool Acc5Digits = true;
extern int Buy.StopLoss = 125;
extern int Buy.TakeProfit = 45;
extern int Buy.OrderDist1 = 25;
extern int Buy.OrderDist2 = 35;
extern int Buy.OrderDist3 = 40;
extern int Sell.StopLoss = 125;
extern int Sell.TakeProfit = 25;
extern int Sell.OrderDist1 = 25;
extern int Sell.OrderDist2 = 35;
extern int Sell.OrderDist3 = 40;
extern int Slippage = 3;
extern int Magic = 20090802;


extern string _tmp2_ = " --- Time section ---";
extern int Buy.GMTDiff = 1;
extern int Buy.OpenH = 20;
extern int Buy.LifeTimeHPos = 13;
extern int Buy.LifeTimeHNeg = 19;
extern int Buy.ExpiredH = 10;

extern int Sell.GMTDiff = 1;
extern int Sell.OpenH = 22;
extern int Sell.LifeTimeHPos = 13;
extern int Sell.LifeTimeHNeg = 11;
extern int Sell.ExpiredH = 11;


extern string _tmp3_ = " --- Trailing ---";
extern bool TrailingOn = false;
extern int TrailingStart = 30;
extern int TrailingSize = 30;


extern string _tmp4_ = " --- Orders color ---";
extern color clBuy = DodgerBlue;
extern color clSell = Red;
extern color clModify = Silver;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <stdlib.mqh>
#include <stderror.mqh>

int RepeatN = 5;

int BuyCnt, SellCnt;
int BuyStopCnt, SellStopCnt;
int BuyLimitCnt, SellLimitCnt;

double MyPoint;

void init() 
{
}

void deinit() 
{
}

void start() 
{
  MyPoint = Point;
  if (Acc5Digits)
  {
    MyPoint = 10*Point;
  }

/*
  if (Period() != PERIOD_H1)
  {
    Alert(Symbol() + ": PERIOD_H1 expected!");
    return;
  }
*/

  if (!IsTradeAllowed())
  {
    Comment(Symbol() + ": trade is not allowed!");
    return;
  }

  //-----
  
  if (TrailingOn) TrailPositions();  

  //-----

  int cnt = OrdersTotal();
  for (int i=cnt-1; i >= 0; i--) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
  
    if (OrderProfit() < 0) continue;
  
    int type = OrderType();
    if (type == OP_BUY) 
    {
      if (TimeCurrent() - OrderOpenTime() < Buy.LifeTimeHPos*60*60) continue;
          
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Bid, Slippage);
      continue;
    }
  
    if (type == OP_SELL) 
    {
      if (TimeCurrent() - OrderOpenTime() < Sell.LifeTimeHPos*60*60) continue;
          
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Ask, Slippage);
      continue;
    }    
  }

  cnt = OrdersTotal();
  for (i=cnt-1; i >= 0; i--) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
  
    if (OrderProfit() > 0) continue;
  
    type = OrderType();
    if (type == OP_BUY) 
    {
      if (TimeCurrent() - OrderOpenTime() < Buy.LifeTimeHNeg*60*60) continue;
          
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Bid, Slippage);
      continue;
    }
  
    if (type == OP_SELL) 
    {
      if (TimeCurrent() - OrderOpenTime() < Sell.LifeTimeHNeg*60*60) continue;
          
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Ask, Slippage);
      continue;
    }    
  }
        
  //-----
  
  RecountOrders();
  
  //-----

  //if (DayOfWeek() != 5) return;

  double price, sl, tp;
  int ticket;
  datetime exp;
  string msg;
  
  int StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL) + 1;
  //Alert(StopLevel);
  
  string comment = WindowExpertName();
  
  double W0 = iHigh(NULL, PERIOD_D1, 0) - iLow(NULL, PERIOD_D1, 0);
  double W1 = iHigh(NULL, PERIOD_D1, 1) - iLow(NULL, PERIOD_D1, 1);


  bool BuySig = (BuyCnt+BuyLimitCnt == 0);
  BuySig = BuySig && (Hour() == GMT(Buy.OpenH, Sell.GMTDiff));
  //BuySig = BuySig && (iHigh(NULL, PERIOD_D1, 0) > iHigh(NULL, PERIOD_D1, 1));
  //BuySig = BuySig && (iHigh(NULL, PERIOD_D1, 0) > iHigh(NULL, PERIOD_D1, 2));
  BuySig = BuySig && (Bid > iMA(NULL, 0, 10, 0, MODE_EMA, 0, 80));
  //BuySig = BuySig && (iMA(NULL, 0, 20, 0, MODE_EMA, 0, 25) < iMA(NULL, 0, 8, 0, MODE_EMA, 0, 0));

  if (BuySig) 
  {
    //double price0 = iLow(NULL, PERIOD_D1, 0);
    
    //if (Ask < iLow(NULL, PERIOD_D1, 1)) price0 = (iHigh(NULL, PERIOD_D1, 0) + iLow(NULL, PERIOD_D1, 0))/2.0;
    //price0 = NormalizeDouble(price0, Digits);
  
    price = iLow(NULL, PERIOD_D1, 0) - Buy.OrderDist1*MyPoint;
    price = NormalizeDouble(price, Digits);
    //if (Ask - price < StopLevel*MyPoint) return;
    //if (Ask - price < StopLevel*MyPoint) price = Ask - StopLevel*MyPoint;
    //Print("* ", (Ask - price)/MyPoint);
    
    sl = IIF(Buy.StopLoss > 0, price - Buy.StopLoss*MyPoint, 0);
    tp = IIF(Buy.TakeProfit > 0, price + Buy.TakeProfit*MyPoint, 0);

    for (i=0; i < RepeatN; i++)
    {
      exp = TimeCurrent() + Buy.ExpiredH*60*60;
      ticket = SetBuyLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }

    price = Bid - Buy.OrderDist2*MyPoint;
    price = NormalizeDouble(price, Digits);
    //if (Ask - price < StopLevel*MyPoint) price = Ask - StopLevel*MyPoint;
    
    sl = IIF(Buy.StopLoss > 0, price - Buy.StopLoss*MyPoint, 0);
    tp = IIF(Buy.TakeProfit > 0, price + (Buy.TakeProfit+0)*MyPoint, 0);

    for (i=0; i < RepeatN; i++)
    { 
      exp = TimeCurrent() + Buy.ExpiredH*60*60;
      ticket = SetBuyLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }

    price = Bid - Buy.OrderDist3*MyPoint;
    price = NormalizeDouble(price, Digits);
    //if (Ask - price < StopLevel*MyPoint) price = Ask - StopLevel*MyPoint;
    
    sl = IIF(Buy.StopLoss > 0, price - Buy.StopLoss*MyPoint, 0);
    tp = IIF(Buy.TakeProfit > 0, price + (Buy.TakeProfit+0)*MyPoint, 0);

    for (i=0; i < RepeatN; i++)
    {   
      exp = TimeCurrent() + Buy.ExpiredH*60*60;
      ticket = SetBuyLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }    
  }


  bool SellSig = (SellCnt+SellLimitCnt == 0);
  SellSig = SellSig && (Hour() == GMT(Sell.OpenH, Sell.GMTDiff));
  //SellSig = SellSig && (Bid > iMA(NULL, 0, 60, 0, MODE_EMA, 0, 5));
  SellSig = SellSig && (iLow(NULL, PERIOD_D1, 0) > iLow(NULL, PERIOD_D1, 1));
  //SellSig = SellSig && (Bid < iMA(NULL, 0, 90, 0, MODE_EMA, 0, 0));
  //SellSig = SellSig && (iMA(NULL, 0, 50, 0, MODE_EMA, 0, 15) < iMA(NULL, 0, 40, 0, MODE_EMA, 0, 0));
  
  if (SellSig)
  {  
    //price = Bid + Sell.OrderDist1*MyPoint;
    price = iHigh(NULL, PERIOD_D1, 0) + Sell.OrderDist1*MyPoint;
    sl = IIF(Sell.StopLoss > 0, price + Sell.StopLoss*MyPoint, 0);
    tp = IIF(Sell.TakeProfit > 0, price - Sell.TakeProfit*MyPoint, 0);  
    
    for (i=0; i < RepeatN; i++)
    {   
      exp = TimeCurrent() + Sell.ExpiredH*60*60;
      ticket = SetSellLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }

    price = Bid + Sell.OrderDist2*MyPoint;
    //price = iHigh(NULL, PERIOD_D1, 0) + Sell.OrderDist2*MyPoint;
    sl = IIF(Sell.StopLoss > 0, price + Sell.StopLoss*MyPoint, 0);
    tp = IIF(Sell.TakeProfit > 0, price - (Sell.TakeProfit+0)*MyPoint, 0);  
    
    for (i=0; i < RepeatN; i++)
    {   
      exp = TimeCurrent() + Sell.ExpiredH*60*60;
      ticket = SetSellLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }


    price = Bid + Sell.OrderDist3*MyPoint;
    //price = iHigh(NULL, PERIOD_D1, 0) + Sell.OrderDist3*MyPoint;
    sl = IIF(Sell.StopLoss > 0, price + Sell.StopLoss*MyPoint, 0);
    tp = IIF(Sell.TakeProfit > 0, price - (Sell.TakeProfit+0)*MyPoint, 0);  
    
    for (i=0; i < RepeatN; i++)
    {   
      exp = TimeCurrent() + Sell.ExpiredH*60*60;
      ticket = SetSellLimit(Symbol(), GetLots(), price, sl, tp, Magic, comment, exp);
      if (ticket > 0) break;
    }
  }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

double IIF(bool cond, double val1, double val2) 
{
  if (cond) return (val1);
  return (val2);
}

int GMT(int hr, int diff) 
{
  int res = hr + diff;
  if (res < 0) res = 24 + res;
  if (res > 23) res = res - 24;
  
  return (res);
}

double GetLots() 
{
  if (DynamicLot)
  {
    double LotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
    double LotPrec = MathCeil(-MathLog(LotStep)/MathLog(10));
  
    double lot = LotBalancePcnt/100.0*AccountBalance()/1000.0;
    lot = NormalizeDouble(lot, LotPrec);
    
    double MaxLot = MarketInfo(Symbol(), MODE_MAXLOT);
    double MinLot = MarketInfo(Symbol(), MODE_MINLOT);    
    lot = MathMax(lot, MinLot);
    lot = MathMin(lot, MaxLot);    
    
    return (lot);
  }
  
  return (Lots);
}

void RecountOrders()
{
  BuyCnt = 0;
  SellCnt = 0;
  BuyStopCnt = 0;
  SellStopCnt = 0;
  BuyLimitCnt = 0;
  SellLimitCnt = 0;

  int cnt = OrdersTotal();
  for (int i=0; i < cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type = OrderType();
    if (type == OP_BUY) BuyCnt++;
    if (type == OP_SELL) SellCnt++;
    if (type == OP_BUYSTOP) BuyStopCnt++;
    if (type == OP_SELLSTOP) SellStopCnt++;
    if (type == OP_BUYLIMIT) BuyLimitCnt++;
    if (type == OP_SELLLIMIT) SellLimitCnt++;
  }
}

/*
double LastOrdersProfit(int ord_cnt) 
{
  double profit = 0;

  int cnt = OrdersHistoryTotal();
  for (int i=cnt-1; i >= 0; i--) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type = OrderType();
    if (type == OP_BUY || type == OP_SELL)
    {
      profit += OrderProfit();
      ord_cnt--;
    }
    
    if (ord_cnt == 0) break;
  }
  
  return (profit);
}
*/

void TrailPositions()
{
  int cnt = OrdersTotal();
  for (int i=0; i<cnt; i++) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;

    int type = OrderType();
    if (type == OP_BUY) 
    {
      if (Bid-OrderOpenPrice() > TrailingStart*MyPoint) 
      {
        if (OrderStopLoss() < Bid - (TrailingSize+1)*MyPoint) 
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-TrailingSize*MyPoint, OrderTakeProfit(), 0, clModify);
        }
      }
    }

    if (type == OP_SELL)
    {
      if (OrderOpenPrice()-Ask > TrailingStart*MyPoint) 
      {
        if (OrderStopLoss() > Ask + (TrailingSize+1)*MyPoint || OrderStopLoss() == 0) 
        {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+TrailingSize*MyPoint, OrderTakeProfit(), 0, clModify);
        }
      }
    }
  }
}

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

int SleepOk = 1000;
int SleepErr = 3000;

int SetBuyLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_BUYLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp, clBuy);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp, clSell);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price, int Slippage) 
{
  if (!OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) return(false);
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  string _lot = DoubleToStr(lot, 1);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", Slippage);
  
  bool res = OrderClose(ticket, lot, price, Slippage);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

