
#property copyright " 2008 RickD"
#property link      "www.e2e-fx.net"

#define major   1
#define minor   1

extern string _tmp1_ = " --- Trade parameters ---";
extern bool Acc5Digits = false;
extern double Lots = 1.0;
extern bool SmartLot = false;
extern int Magic = 20080413;
extern int Slippage = 3;
extern int GMT.Diff = 1;

extern string _tmp2_ = " --- MM section ---";
extern bool EnableMM = false;
extern double LotBalancePcnt = 10;
extern double MinLot = 0.1;
extern double MaxLot = 5;
extern int LotPrec = 1;

extern string _tmp3_ = " --- Days of Week ---";
extern bool L.D1.Trade = true;
extern int L.D1.h1 = 17;
extern int L.D1.h2 = 3;
extern int L.D1.TP = 17;
extern int L.D1.dy = 15;
extern int L.D1.MinW = 46;

extern bool L.D2.Trade = true;
extern int L.D2.h1 = 21;
extern int L.D2.h2 = 2;
extern int L.D2.TP = 20;
extern int L.D2.dy = 15;
extern int L.D2.MinW = 75;

extern bool L.D3.Trade = true;
extern int L.D3.h1 = 21;
extern int L.D3.h2 = 8;
extern int L.D3.TP = 19;
extern int L.D3.dy = 15;
extern int L.D3.MinW = 58;

extern bool L.D4.Trade = true;
extern int L.D4.h1 = 23;
extern int L.D4.h2 = 2;
extern int L.D4.TP = 49;
extern int L.D4.dy = 19;
extern int L.D4.MinW = 60;


extern bool S.D1.Trade = false;
extern int S.D1.h1 = 17;
extern int S.D1.h2 = 15;
extern int S.D1.TP = 36;
extern int S.D1.dy = 10;
extern int S.D1.MinW = 120;

extern bool S.D2.Trade = true;
extern int S.D2.h1 = 21;
extern int S.D2.h2 = 6;
extern int S.D2.TP = 35;
extern int S.D2.dy = 35;
extern int S.D2.MinW = 54;

extern bool S.D3.Trade = true;
extern int S.D3.h1 = 22;
extern int S.D3.h2 = 2;
extern int S.D3.TP = 45;
extern int S.D3.dy = 23;
extern int S.D3.MinW = 58;

extern bool S.D4.Trade = true;
extern int S.D4.h1 = 20;
extern int S.D4.h2 = 4;
extern int S.D4.TP = 35;
extern int S.D4.dy = 25;
extern int S.D4.MinW = 34;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#define B   0
#define S   1

bool Trade[2][7];
int h1[2][7];
int h2[2][7];
int TP[2][7];
int dy[2][7];
int MinW[2][7];

double W0[2];
int DW = 0;

int kB = 0;
int kS = 0;

bool BuyCond = false;
bool SellCond = false;
bool BuyCloseCond = false;
bool SellCloseCond = false;

double max0 = 0.0;
double min0 = 0.0;
  
int h0 = 0;
int m0 = 0;
int BuyCnt = 0;
int SellCnt = 0;

double BuyPrice = 0.0;
double SellPrice = 0.0;

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

#include <stdlib.mqh>
#include <stderror.mqh>

int init () {
  if (!IsTesting()) Comment("");
  return(0);
}

int deinit() {
  if (!IsTesting()) Comment("");
  return(0);
}

//+------------------------------------------------------------------+

int GetSL() 
{
  int sl = 73;
  
  if (Acc5Digits)
  {
    sl *= 10;
  }
  
  return (sl);
}

int start() {

  if (!IsTesting()) Comment("Time: ", TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS));

  if (Period() != PERIOD_H1) {
    Comment(Symbol() + ": PERIOD_H1 expected!");
    return (-1);
  }  

  if (!IsTradeAllowed()) {
    Comment(Symbol() + ": trade is not allowed!");
    return (-1);
  }
        
    
  BuyCond = false;
  SellCond = false;
  
  h0 = TimeHour(Time[0]);
  m0 = TimeMinute(Time[0]);
  DW = DayOfWeek();
    
  USDCAD();
  

  BuyCnt = GetOrders(Symbol(), OP_BUY);
  SellCnt = GetOrders(Symbol(), OP_SELL);

  int minW = MinW[B][DW];
  if (Acc5Digits)
  {
    minW *= 10;
  }

  BuyCond = BuyCond &&
    (BuyCnt == 0) && Trade[B][DW] && (h0 == GMT(h1[B][DW], GMT.Diff)) &&
    (W0[B] > minW*Point) &&
    (TimeCurrent() - LastOpenTime(OP_BUY) > 2*60*60);

  minW = MinW[S][DW];
  if (Acc5Digits)
  {
    minW *= 10;
  }
     
  SellCond = SellCond &&
    (SellCnt == 0) && Trade[S][DW] && (h0 == GMT(h1[S][DW], GMT.Diff)) &&
    (W0[S] > minW*Point) &&
    (TimeCurrent() - LastOpenTime(OP_SELL) > 2*60*60);
  
  int _dy = dy[B][DW];
  if (Acc5Digits)
  {
    _dy *= 10;
  }
  
  BuyPrice = Ask - _dy*Point;

  _dy = dy[S][DW];
  if (Acc5Digits)
  {
    _dy *= 10;
  }

  SellPrice = Bid + _dy*Point;
  
  if (BuyCond) OpenOrders(OP_BUY);
  if (SellCond) OpenOrders(OP_SELL);


  if (BuyCnt > 0) {
    CloseOrders(OP_BUY);
    DeleteOrders(OP_BUYLIMIT);
  }
  
  if (SellCnt > 0) {
    CloseOrders(OP_SELL);
    DeleteOrders(OP_SELLLIMIT);
  }

  return(0);
}

int USDCAD() 
{
  max0 = High[Highest(NULL, 0, MODE_HIGH, 1*24, 1)];
  min0 = Low[Lowest(NULL, 0, MODE_LOW, 1*24, 1)];
  W0[B] = (max0-min0);  

  Trade[B][1] = false;
  Trade[B][2] = false;
  Trade[B][3] = false;
  Trade[B][4] = false;
  Trade[B][5] = false;

  if (L.D1.Trade)
  {
    Trade[B][1] = true;
    h1[B][1] = L.D1.h1;
    h2[B][2] = L.D1.h2;
    TP[B][1] = L.D1.TP;  
    dy[B][1] = L.D1.dy;  
    MinW[B][1] = L.D1.MinW;
  }
  
  if (L.D2.Trade)
  {
    Trade[B][2] = true;
    h1[B][2] = L.D2.h1;
    h2[B][3] = L.D2.h2;
    TP[B][2] = L.D2.TP;  
    dy[B][2] = L.D2.dy;  
    MinW[B][2] = L.D2.MinW;
  }

  if (L.D3.Trade)
  {
    Trade[B][3] = true;
    h1[B][3] = L.D3.h1;
    h2[B][4] = L.D3.h2;
    TP[B][3] = L.D3.TP;  
    dy[B][3] = L.D3.dy;  
    MinW[B][3] = L.D3.MinW;
  }

  if (L.D4.Trade)
  {
    Trade[B][4] = true;
    h1[B][4] = L.D4.h1;
    h2[B][5] = L.D4.h2;
    TP[B][4] = L.D4.TP;  
    dy[B][4] = L.D4.dy;  
    MinW[B][4] = L.D4.MinW;
  }
 
  h1[B][5] = -1;
  h2[B][1] = -1;

  BuyCond = (DW <= 5);

  //-----
  
  max0 = High[Highest(NULL, 0, MODE_HIGH, 1*24, 1)];
  min0 = Low[Lowest(NULL, 0, MODE_LOW, 1*24, 1)];
  W0[S] = (max0-min0);  

  Trade[S][1] = false;
  Trade[S][2] = false;
  Trade[S][3] = false;
  Trade[S][4] = false;
  Trade[S][5] = false;

  if (S.D1.Trade)
  {
    Trade[S][1] = true;
    h1[S][1] = S.D1.h1;
    h2[S][2] = S.D1.h2;
    TP[S][1] = S.D1.TP;  
    dy[S][1] = S.D1.dy;  
    MinW[S][1] = S.D1.MinW;
  }
  
  if (S.D2.Trade)
  {
    Trade[S][2] = true;
    h1[S][2] = S.D2.h1;
    h2[S][3] = S.D2.h2;
    TP[S][2] = S.D2.TP;  
    dy[S][2] = S.D2.dy;  
    MinW[S][2] = S.D2.MinW;
  }

  if (S.D3.Trade)
  {
    Trade[S][3] = true;
    h1[S][3] = S.D3.h1;
    h2[S][4] = S.D3.h2;
    TP[S][3] = S.D3.TP;  
    dy[S][3] = S.D3.dy;  
    MinW[S][3] = S.D3.MinW;
  }

  if (S.D4.Trade)
  {
    Trade[S][4] = true;
    h1[S][4] = S.D4.h1;
    h2[S][5] = S.D4.h2;
    TP[S][4] = S.D4.TP;  
    dy[S][4] = S.D4.dy;  
    MinW[S][4] = S.D4.MinW;
  }
 
  h1[S][5] = -1;
  h2[S][1] = -1;
        
  SellCond = (DW <= 5);

  return(0);
}

//+------------------------------------------------------------------+

int GMT(int hr, int diff) 
{
  int res = hr + diff;
  if (res < 0) res = 24 + res;
  if (res > 23) res = res - 24;
  
  return (res);
}

double GetLots() 
{
  if (SmartLot)
  {
    if (LastOrdersProfit(1) > 0) return (2*Lots);  
  }
  
  if (EnableMM)
  {
    double Bal0 = 1000;
    if (LotPrec == 2) Bal0 = 100;
  
    double lots = NormalizeDouble(LotBalancePcnt/100*AccountBalance()/Bal0, LotPrec);
    lots = MathMax(lots, MinLot);
    lots = MathMin(lots, MaxLot);
    return (lots);
  }

  return (1*Lots);
}

int MaxAge(int T) 
{
  int ND = DW + 1;
  if (ND > 5) ND = 1;
  
  int H1 = h1[T][DW];
  int H2 = h2[T][ND];
  
  int hh = 24 - H1 + H2;
  if (ND == 1) hh += 2*24;
  
  int tm0 = StrToTime("0:00") + H1*60*60;
  return (tm0 + hh*60*60);
}

double LastOrdersProfit(int ord_cnt) 
{
  double profit = 0;

  int cnt = OrdersHistoryTotal();
  for (int i=cnt-1; i >= 0; i--) 
  {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) continue;
    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type = OrderType();
    if (type == OP_BUY || type == OP_SELL)
    {
      profit += OrderProfit();
      ord_cnt--;
    }
    
    if (ord_cnt == 0) break;
  }
  
  return (profit);
}

int OpenOrders(int type)
{
  double price = 0.0;

  if (type == OP_BUY) {
    price = BuyPrice;
    
    int tp = TP[B][DW];
    
    if (Acc5Digits)
    {
      tp *= 10;
    }
    
    int res = SetBuyLimit(Symbol(), GetLots(), price, price-GetSL()*Point, price+tp*Point, Magic, MaxAge(B));
    
    return (res);
  }

  if (type == OP_SELL) {
    price = SellPrice;
    
    tp = TP[S][DW];
    
    if (Acc5Digits)
    {
      tp *= 10;
    }
    
    res = SetSellLimit(Symbol(), GetLots(), price, price+GetSL()*Point, price-tp*Point, Magic, MaxAge(S));
    
    return (res);
  }
  
  return(0);
}

int CloseOrders(int type) {

  int cnt = OrdersTotal();
  for (int i=cnt-1; i >= 0; i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;

    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int MaxAge = StrToInteger(OrderComment());
    if (CurTime() < MaxAge) continue;
    
    int type2 = OrderType();
    if (type != type2) continue;
    
    if (type == OP_BUY) {
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Bid);
    }
          
    if (type == OP_SELL) {
      RefreshRates();
      CloseOrder(OrderTicket(), OrderLots(), Ask);
    }
  }
  
  return(0);
}

int DeleteOrders(int type) {

  int cnt = OrdersTotal();
  for (int i=cnt-1; i >= 0; i--) {
    if (!OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) continue;

    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int MaxAge = StrToInteger(OrderComment());
    MaxAge -= 1*60*60;
    if (CurTime() < MaxAge) continue;
    
    int type2 = OrderType();
    if (type != type2) continue;
    
    DeleteOrder(OrderTicket());
  }
  
  return(0);
}

int GetOrders(string symbol, int type) {

  int res = 0;
  int cnt = OrdersTotal();
  for (int i=0; i < cnt; i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
    
    if (OrderSymbol() != symbol) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    int type2 = OrderType();
    if (type == OP_BUY) {
      if (type2 == OP_BUY || type2 == OP_BUYLIMIT) res++;
    }

    if (type == OP_SELL) {
      if (type2 == OP_SELL || type2 == OP_SELLLIMIT) res++;
    }
  }
  
  return(res);
}

datetime LastOpenTime(int type) {
  datetime tm = 0;
  
  int cnt = OrdersHistoryTotal();
  for (int i=0; i < cnt; i++) {
    OrderSelect(i, SELECT_BY_POS, MODE_HISTORY);

    if (OrderSymbol() != Symbol()) continue;
    if (OrderMagicNumber() != Magic) continue;
    
    if (OrderType() == type) {
      if (OrderOpenTime() > tm) tm = OrderOpenTime();
    }
  }

  return(tm);
}

//---------------------------------------------------------------------------------------------------------------------------

int SleepOk = 2000;
int SleepErr = 6000;

int SetBuyLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetBuyLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_BUYLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting BUYLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

int SetSellLimit(string symbol, double lot, double price, double sl, double tp, int magic, string comment="", datetime exp=0) 
{
  int dig = MarketInfo(symbol, MODE_DIGITS);

  price = NormalizeDouble(price, dig);
  sl = NormalizeDouble(sl, dig);
  tp = NormalizeDouble(tp, dig);
  
  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);
  string _sl = DoubleToStr(sl, dig);
  string _tp = DoubleToStr(tp, dig);

  Print("SetSellLimit \"", symbol, "\", ", _lot, ", ", _price, ", ", Slippage, ", ", _sl, ", ", _tp, ", ", magic, ", \"", comment, "\"");
  
  int res = OrderSend(symbol, OP_SELLLIMIT, lot, price, Slippage, sl, tp, comment, magic, exp);
  if (res >= 0) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("Error setting SELLLIMIT order: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (-1);
}

bool CloseOrder(int ticket, double lot, double price) 
{
  if (!OrderSelect(ticket, SELECT_BY_TICKET, MODE_TRADES)) return(false);
  int dig = MarketInfo(OrderSymbol(), MODE_DIGITS);

  string _lot = DoubleToStr(lot, 2);
  string _price = DoubleToStr(price, dig);

  Print("CloseOrder ", ticket, ", ", _lot, ", ", _price, ", ", Slippage);
  
  bool res = OrderClose(ticket, lot, price, Slippage);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("CloseOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}

bool DeleteOrder(int ticket) 
{
  Print("DeleteOrder ", ticket);
  
  bool res = OrderDelete(ticket);
  if (res) {
    Sleep(SleepOk);
    return (res);
  } 	
   	
  int code = GetLastError();
  Print("DeleteOrder failed: ", ErrorDescription(code), " (", code, ")");
  Sleep(SleepErr);
	
  return (false);
}



